diff --git a/oflog/libsrc/Makefile.dep b/oflog/libsrc/Makefile.dep
index a7a7b1f..6562f92 100644
--- a/oflog/libsrc/Makefile.dep
+++ b/oflog/libsrc/Makefile.dep
@@ -655,28 +1018,24 @@ rootlog.o: rootlog.cc ../include/dcmtk/oflog/spi/rootlog.h \
  ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
  ../include/dcmtk/oflog/config/defines.h \
  ../include/dcmtk/oflog/helpers/threadcf.h \
- ../include/dcmtk/oflog/helpers/loglog.h ../include/dcmtk/oflog/tstring.h \
+ ../include/dcmtk/oflog/spi/logimpl.h ../include/dcmtk/oflog/tstring.h \
  ../../ofstd/include/dcmtk/ofstd/ofstring.h \
  ../../ofstd/include/dcmtk/ofstd/oftypes.h \
  ../../ofstd/include/dcmtk/ofstd/ofstream.h \
+ ../include/dcmtk/oflog/tchar.h ../include/dcmtk/oflog/helpers/apndimpl.h \
  ../include/dcmtk/oflog/helpers/pointer.h \
- ../include/dcmtk/oflog/helpers/threads.h \
- ../include/dcmtk/oflog/spi/logimpl.h \
- ../include/dcmtk/oflog/helpers/apndimpl.h \
- ../include/dcmtk/oflog/layout.h ../include/dcmtk/oflog/loglevel.h \
- ../include/dcmtk/oflog/streams.h \
- ../include/dcmtk/oflog/helpers/lloguser.h \
- ../include/dcmtk/oflog/helpers/property.h \
- ../../ofstd/include/dcmtk/ofstd/ofmap.h \
- ../../ofstd/include/dcmtk/ofstd/oflist.h \
- ../include/dcmtk/oflog/helpers/timehelp.h \
- ../include/dcmtk/oflog/spi/logevent.h ../include/dcmtk/oflog/ndc.h \
- ../../ofstd/include/dcmtk/ofstd/ofstack.h \
- ../../ofstd/include/dcmtk/ofstd/ofaptr.h \
+ ../include/dcmtk/oflog/thread/syncprim.h \
  ../include/dcmtk/oflog/spi/apndatch.h ../include/dcmtk/oflog/appender.h \
- ../include/dcmtk/oflog/spi/filter.h ../include/dcmtk/oflog/spi/logfact.h
-sleep.o: sleep.cc ../include/dcmtk/oflog/helpers/sleep.h \
- ../include/dcmtk/oflog/config.h \
+ ../../ofstd/include/dcmtk/ofstd/ofaptr.h ../include/dcmtk/oflog/layout.h \
+ ../include/dcmtk/oflog/loglevel.h \
+ ../../ofstd/include/dcmtk/ofstd/ofvector.h \
+ ../include/dcmtk/oflog/streams.h ../include/dcmtk/oflog/spi/filter.h \
+ ../include/dcmtk/oflog/helpers/lockfile.h \
+ ../include/dcmtk/oflog/spi/logfact.h \
+ ../include/dcmtk/oflog/helpers/loglog.h \
+ ../include/dcmtk/oflog/thread/syncpub.h
+sleep.o: sleep.cc ../include/dcmtk/oflog/config/windowsh.h \
+ ../include/dcmtk/oflog/helpers/sleep.h ../include/dcmtk/oflog/config.h \
  ../../config/include/dcmtk/config/osconfig.h \
  ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
  ../../ofstd/include/dcmtk/ofstd/ofcast.h \
@@ -684,12 +1043,38 @@ sleep.o: sleep.cc ../include/dcmtk/oflog/helpers/sleep.h \
  ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
  ../include/dcmtk/oflog/config/defines.h \
  ../include/dcmtk/oflog/helpers/threadcf.h \
- ../../ofstd/include/dcmtk/ofstd/ofstd.h \
- ../../ofstd/include/dcmtk/ofstd/oflist.h \
+ ../include/dcmtk/oflog/helpers/timehelp.h \
+ ../include/dcmtk/oflog/tstring.h \
+ ../../ofstd/include/dcmtk/ofstd/ofstring.h \
+ ../../ofstd/include/dcmtk/ofstd/oftypes.h \
+ ../../ofstd/include/dcmtk/ofstd/ofstream.h \
+ ../include/dcmtk/oflog/tchar.h
+snprintf.o: snprintf.cc ../include/dcmtk/oflog/helpers/snprintf.h \
+ ../include/dcmtk/oflog/config.h \
+ ../../config/include/dcmtk/config/osconfig.h \
+ ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
+ ../../ofstd/include/dcmtk/ofstd/ofcast.h \
+ ../../ofstd/include/dcmtk/ofstd/ofexport.h \
+ ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
+ ../include/dcmtk/oflog/config/defines.h \
+ ../include/dcmtk/oflog/helpers/threadcf.h ../include/dcmtk/oflog/tchar.h \
+ ../../ofstd/include/dcmtk/ofstd/ofvector.h \
  ../../ofstd/include/dcmtk/ofstd/oftypes.h \
+ ../include/dcmtk/oflog/helpers/loglog.h ../include/dcmtk/oflog/tstring.h \
  ../../ofstd/include/dcmtk/ofstd/ofstring.h \
  ../../ofstd/include/dcmtk/ofstd/ofstream.h \
- ../../ofstd/include/dcmtk/ofstd/ofcond.h
+ ../include/dcmtk/oflog/streams.h \
+ ../include/dcmtk/oflog/thread/syncprim.h \
+ ../include/dcmtk/oflog/internal/internal.h ../include/dcmtk/oflog/ndc.h \
+ ../include/dcmtk/oflog/mdc.h ../../ofstd/include/dcmtk/ofstd/ofmap.h \
+ ../../ofstd/include/dcmtk/ofstd/oflist.h \
+ ../include/dcmtk/oflog/spi/logevent.h \
+ ../../ofstd/include/dcmtk/ofstd/ofaptr.h \
+ ../include/dcmtk/oflog/loglevel.h \
+ ../include/dcmtk/oflog/helpers/timehelp.h \
+ ../include/dcmtk/oflog/thread/threads.h \
+ ../include/dcmtk/oflog/helpers/pointer.h \
+ ../include/dcmtk/oflog/thread/impl/tls.h
 sockbuff.o: sockbuff.cc ../include/dcmtk/oflog/helpers/sockbuff.h \
  ../include/dcmtk/oflog/config.h \
  ../../config/include/dcmtk/config/osconfig.h \
@@ -703,11 +1088,10 @@ sockbuff.o: sockbuff.cc ../include/dcmtk/oflog/helpers/sockbuff.h \
  ../../ofstd/include/dcmtk/ofstd/ofstring.h \
  ../../ofstd/include/dcmtk/ofstd/oftypes.h \
  ../../ofstd/include/dcmtk/ofstd/ofstream.h \
- ../include/dcmtk/oflog/helpers/lloguser.h \
- ../include/dcmtk/oflog/helpers/loglog.h \
- ../include/dcmtk/oflog/helpers/pointer.h \
- ../include/dcmtk/oflog/helpers/threads.h
-socket.o: socket.cc ../include/dcmtk/oflog/helpers/socket.h \
+ ../include/dcmtk/oflog/tchar.h ../include/dcmtk/oflog/helpers/loglog.h \
+ ../include/dcmtk/oflog/streams.h \
+ ../include/dcmtk/oflog/thread/syncprim.h
+socketap.o: socketap.cc ../include/dcmtk/oflog/socketap.h \
  ../include/dcmtk/oflog/config.h \
  ../../config/include/dcmtk/config/osconfig.h \
  ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
@@ -716,16 +1100,31 @@ socket.o: socket.cc ../include/dcmtk/oflog/helpers/socket.h \
  ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
  ../include/dcmtk/oflog/config/defines.h \
  ../include/dcmtk/oflog/helpers/threadcf.h \
+ ../include/dcmtk/oflog/appender.h \
+ ../../ofstd/include/dcmtk/ofstd/ofaptr.h ../include/dcmtk/oflog/layout.h \
+ ../include/dcmtk/oflog/loglevel.h \
+ ../../ofstd/include/dcmtk/ofstd/ofvector.h \
+ ../../ofstd/include/dcmtk/ofstd/oftypes.h \
  ../include/dcmtk/oflog/tstring.h \
  ../../ofstd/include/dcmtk/ofstd/ofstring.h \
- ../../ofstd/include/dcmtk/ofstd/oftypes.h \
  ../../ofstd/include/dcmtk/ofstd/ofstream.h \
+ ../include/dcmtk/oflog/tchar.h ../include/dcmtk/oflog/streams.h \
+ ../include/dcmtk/oflog/helpers/pointer.h \
+ ../include/dcmtk/oflog/thread/syncprim.h \
+ ../include/dcmtk/oflog/spi/filter.h \
+ ../include/dcmtk/oflog/helpers/lockfile.h \
+ ../include/dcmtk/oflog/helpers/socket.h \
  ../include/dcmtk/oflog/helpers/sockbuff.h \
- ../include/dcmtk/oflog/helpers/lloguser.h \
+ ../include/dcmtk/oflog/thread/threads.h \
+ ../include/dcmtk/oflog/spi/logevent.h ../include/dcmtk/oflog/ndc.h \
+ ../include/dcmtk/oflog/mdc.h ../../ofstd/include/dcmtk/ofstd/ofmap.h \
+ ../../ofstd/include/dcmtk/ofstd/oflist.h \
+ ../include/dcmtk/oflog/helpers/timehelp.h \
  ../include/dcmtk/oflog/helpers/loglog.h \
- ../include/dcmtk/oflog/helpers/pointer.h \
- ../include/dcmtk/oflog/helpers/threads.h
-socketap.o: socketap.cc ../include/dcmtk/oflog/socketap.h \
+ ../include/dcmtk/oflog/helpers/sleep.h \
+ ../include/dcmtk/oflog/helpers/property.h \
+ ../include/dcmtk/oflog/thread/syncpub.h
+socket.o: socket.cc ../include/dcmtk/oflog/helpers/loglog.h \
  ../include/dcmtk/oflog/config.h \
  ../../config/include/dcmtk/config/osconfig.h \
  ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
@@ -734,30 +1133,16 @@ socketap.o: socketap.cc ../include/dcmtk/oflog/socketap.h \
  ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
  ../include/dcmtk/oflog/config/defines.h \
  ../include/dcmtk/oflog/helpers/threadcf.h \
- ../include/dcmtk/oflog/appender.h ../include/dcmtk/oflog/layout.h \
- ../include/dcmtk/oflog/loglevel.h ../include/dcmtk/oflog/streams.h \
  ../include/dcmtk/oflog/tstring.h \
  ../../ofstd/include/dcmtk/ofstd/ofstring.h \
  ../../ofstd/include/dcmtk/ofstd/oftypes.h \
  ../../ofstd/include/dcmtk/ofstd/ofstream.h \
- ../include/dcmtk/oflog/helpers/lloguser.h \
- ../include/dcmtk/oflog/helpers/property.h \
- ../../ofstd/include/dcmtk/ofstd/ofmap.h \
- ../../ofstd/include/dcmtk/ofstd/oflist.h \
- ../include/dcmtk/oflog/helpers/timehelp.h \
- ../include/dcmtk/oflog/spi/logevent.h ../include/dcmtk/oflog/ndc.h \
- ../include/dcmtk/oflog/helpers/threads.h \
- ../include/dcmtk/oflog/helpers/pointer.h \
- ../../ofstd/include/dcmtk/ofstd/ofstack.h \
- ../../ofstd/include/dcmtk/ofstd/ofaptr.h \
- ../include/dcmtk/oflog/spi/filter.h \
+ ../include/dcmtk/oflog/tchar.h ../include/dcmtk/oflog/streams.h \
+ ../include/dcmtk/oflog/thread/syncprim.h \
+ ../include/dcmtk/oflog/internal/socket.h \
  ../include/dcmtk/oflog/helpers/socket.h \
- ../include/dcmtk/oflog/helpers/sockbuff.h \
- ../include/dcmtk/oflog/helpers/syncprims.h \
- ../include/dcmtk/oflog/helpers/syncppth.h \
- ../include/dcmtk/oflog/helpers/loglog.h \
- ../include/dcmtk/oflog/helpers/sleep.h
-strhelp.o: strhelp.cc ../include/dcmtk/oflog/helpers/strhelp.h \
+ ../include/dcmtk/oflog/helpers/sockbuff.h
+strccloc.o: strccloc.cc ../include/dcmtk/oflog/helpers/strhelp.h \
  ../include/dcmtk/oflog/config.h \
  ../../config/include/dcmtk/config/osconfig.h \
  ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
@@ -770,11 +1155,10 @@ strhelp.o: strhelp.cc ../include/dcmtk/oflog/helpers/strhelp.h \
  ../../ofstd/include/dcmtk/ofstd/ofstring.h \
  ../../ofstd/include/dcmtk/ofstd/oftypes.h \
  ../../ofstd/include/dcmtk/ofstd/ofstream.h \
- ../../ofstd/include/dcmtk/ofstd/oflist.h \
- ../include/dcmtk/oflog/streams.h ../include/dcmtk/oflog/logmacro.h \
- ../../ofstd/include/dcmtk/ofstd/ofstd.h \
- ../../ofstd/include/dcmtk/ofstd/ofcond.h
-syncprims.o: syncprims.cc ../include/dcmtk/oflog/helpers/syncprims.h \
+ ../include/dcmtk/oflog/tchar.h \
+ ../../ofstd/include/dcmtk/ofstd/ofvector.h \
+ ../include/dcmtk/oflog/streams.h
+strcloc.o: strcloc.cc ../include/dcmtk/oflog/helpers/strhelp.h \
  ../include/dcmtk/oflog/config.h \
  ../../config/include/dcmtk/config/osconfig.h \
  ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
@@ -783,15 +1167,15 @@ syncprims.o: syncprims.cc ../include/dcmtk/oflog/helpers/syncprims.h \
  ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
  ../include/dcmtk/oflog/config/defines.h \
  ../include/dcmtk/oflog/helpers/threadcf.h \
- ../include/dcmtk/oflog/helpers/timehelp.h \
  ../include/dcmtk/oflog/tstring.h \
  ../../ofstd/include/dcmtk/ofstd/ofstring.h \
  ../../ofstd/include/dcmtk/ofstd/oftypes.h \
  ../../ofstd/include/dcmtk/ofstd/ofstream.h \
- ../include/dcmtk/oflog/helpers/syncppth.h \
- ../../ofstd/include/dcmtk/ofstd/ofconsol.h \
- ../../ofstd/include/dcmtk/ofstd/ofthread.h
-syslogap.o: syslogap.cc ../include/dcmtk/oflog/syslogap.h \
+ ../include/dcmtk/oflog/tchar.h \
+ ../../ofstd/include/dcmtk/ofstd/ofvector.h \
+ ../include/dcmtk/oflog/helpers/loglog.h ../include/dcmtk/oflog/streams.h \
+ ../include/dcmtk/oflog/thread/syncprim.h
+strhelp.o: strhelp.cc ../include/dcmtk/oflog/helpers/strhelp.h \
  ../include/dcmtk/oflog/config.h \
  ../../config/include/dcmtk/config/osconfig.h \
  ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
@@ -800,48 +1184,42 @@ syslogap.o: syslogap.cc ../include/dcmtk/oflog/syslogap.h \
  ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
  ../include/dcmtk/oflog/config/defines.h \
  ../include/dcmtk/oflog/helpers/threadcf.h \
- ../include/dcmtk/oflog/appender.h ../include/dcmtk/oflog/layout.h \
- ../include/dcmtk/oflog/loglevel.h ../include/dcmtk/oflog/streams.h \
  ../include/dcmtk/oflog/tstring.h \
  ../../ofstd/include/dcmtk/ofstd/ofstring.h \
  ../../ofstd/include/dcmtk/ofstd/oftypes.h \
  ../../ofstd/include/dcmtk/ofstd/ofstream.h \
- ../include/dcmtk/oflog/helpers/lloguser.h \
- ../include/dcmtk/oflog/helpers/property.h \
- ../../ofstd/include/dcmtk/ofstd/ofmap.h \
+ ../include/dcmtk/oflog/tchar.h \
+ ../../ofstd/include/dcmtk/ofstd/ofvector.h \
+ ../include/dcmtk/oflog/streams.h ../../ofstd/include/dcmtk/ofstd/ofstd.h \
  ../../ofstd/include/dcmtk/ofstd/oflist.h \
+ ../../ofstd/include/dcmtk/ofstd/ofcond.h \
+ ../include/dcmtk/oflog/internal/internal.h ../include/dcmtk/oflog/ndc.h \
+ ../include/dcmtk/oflog/mdc.h ../../ofstd/include/dcmtk/ofstd/ofmap.h \
+ ../include/dcmtk/oflog/spi/logevent.h \
+ ../../ofstd/include/dcmtk/ofstd/ofaptr.h \
+ ../include/dcmtk/oflog/loglevel.h \
  ../include/dcmtk/oflog/helpers/timehelp.h \
- ../include/dcmtk/oflog/spi/logevent.h ../include/dcmtk/oflog/ndc.h \
- ../include/dcmtk/oflog/helpers/threads.h \
+ ../include/dcmtk/oflog/thread/threads.h \
  ../include/dcmtk/oflog/helpers/pointer.h \
- ../../ofstd/include/dcmtk/ofstd/ofstack.h \
- ../../ofstd/include/dcmtk/ofstd/ofaptr.h \
- ../include/dcmtk/oflog/spi/filter.h \
- ../include/dcmtk/oflog/helpers/loglog.h
-threads.o: threads.cc ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
- ../../config/include/dcmtk/config/osconfig.h \
+ ../include/dcmtk/oflog/thread/syncprim.h \
+ ../include/dcmtk/oflog/thread/impl/tls.h \
+ ../include/dcmtk/oflog/helpers/snprintf.h
+striconv.o: striconv.cc ../include/dcmtk/oflog/helpers/strhelp.h \
  ../include/dcmtk/oflog/config.h \
+ ../../config/include/dcmtk/config/osconfig.h \
  ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
  ../../ofstd/include/dcmtk/ofstd/ofcast.h \
  ../../ofstd/include/dcmtk/ofstd/ofexport.h \
+ ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
  ../include/dcmtk/oflog/config/defines.h \
  ../include/dcmtk/oflog/helpers/threadcf.h \
- ../include/dcmtk/oflog/helpers/threads.h \
  ../include/dcmtk/oflog/tstring.h \
  ../../ofstd/include/dcmtk/ofstd/ofstring.h \
  ../../ofstd/include/dcmtk/ofstd/oftypes.h \
  ../../ofstd/include/dcmtk/ofstd/ofstream.h \
- ../include/dcmtk/oflog/helpers/pointer.h \
- ../include/dcmtk/oflog/streams.h ../include/dcmtk/oflog/ndc.h \
- ../include/dcmtk/oflog/helpers/lloguser.h \
- ../../ofstd/include/dcmtk/ofstd/ofstack.h \
- ../include/dcmtk/oflog/helpers/loglog.h \
- ../include/dcmtk/oflog/helpers/strhelp.h \
- ../../ofstd/include/dcmtk/ofstd/oflist.h \
- ../include/dcmtk/oflog/helpers/timehelp.h \
- ../include/dcmtk/oflog/helpers/syncprims.h \
- ../include/dcmtk/oflog/helpers/syncppth.h
-timehelp.o: timehelp.cc ../include/dcmtk/oflog/helpers/timehelp.h \
+ ../include/dcmtk/oflog/tchar.h \
+ ../../ofstd/include/dcmtk/ofstd/ofvector.h
+syncprims.o: syncprims.cc ../include/dcmtk/oflog/thread/syncpub.h \
  ../include/dcmtk/oflog/config.h \
  ../../config/include/dcmtk/config/osconfig.h \
  ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
@@ -850,14 +1228,18 @@ timehelp.o: timehelp.cc ../include/dcmtk/oflog/helpers/timehelp.h \
  ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
  ../include/dcmtk/oflog/config/defines.h \
  ../include/dcmtk/oflog/helpers/threadcf.h \
+ ../include/dcmtk/oflog/thread/syncprim.h \
+ ../include/dcmtk/oflog/thread/impl/syncimpl.h \
+ ../include/dcmtk/oflog/helpers/timehelp.h \
  ../include/dcmtk/oflog/tstring.h \
  ../../ofstd/include/dcmtk/ofstd/ofstring.h \
  ../../ofstd/include/dcmtk/ofstd/oftypes.h \
  ../../ofstd/include/dcmtk/ofstd/ofstream.h \
- ../include/dcmtk/oflog/streams.h \
- ../include/dcmtk/oflog/helpers/strhelp.h \
- ../../ofstd/include/dcmtk/ofstd/oflist.h
-unixsock.o: unixsock.cc ../include/dcmtk/oflog/helpers/socket.h \
+ ../include/dcmtk/oflog/tchar.h \
+ ../include/dcmtk/oflog/thread/impl/syncpthr.h \
+ ../include/dcmtk/oflog/thread/threads.h \
+ ../include/dcmtk/oflog/helpers/pointer.h
+syslogap.o: syslogap.cc ../include/dcmtk/oflog/syslogap.h \
  ../include/dcmtk/oflog/config.h \
  ../../config/include/dcmtk/config/osconfig.h \
  ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
@@ -866,21 +1248,70 @@ unixsock.o: unixsock.cc ../include/dcmtk/oflog/helpers/socket.h \
  ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
  ../include/dcmtk/oflog/config/defines.h \
  ../include/dcmtk/oflog/helpers/threadcf.h \
+ ../include/dcmtk/oflog/appender.h \
+ ../../ofstd/include/dcmtk/ofstd/ofaptr.h ../include/dcmtk/oflog/layout.h \
+ ../include/dcmtk/oflog/loglevel.h \
+ ../../ofstd/include/dcmtk/ofstd/ofvector.h \
+ ../../ofstd/include/dcmtk/ofstd/oftypes.h \
  ../include/dcmtk/oflog/tstring.h \
  ../../ofstd/include/dcmtk/ofstd/ofstring.h \
- ../../ofstd/include/dcmtk/ofstd/oftypes.h \
  ../../ofstd/include/dcmtk/ofstd/ofstream.h \
+ ../include/dcmtk/oflog/tchar.h ../include/dcmtk/oflog/streams.h \
+ ../include/dcmtk/oflog/helpers/pointer.h \
+ ../include/dcmtk/oflog/thread/syncprim.h \
+ ../include/dcmtk/oflog/spi/filter.h \
+ ../include/dcmtk/oflog/helpers/lockfile.h \
+ ../include/dcmtk/oflog/helpers/socket.h \
  ../include/dcmtk/oflog/helpers/sockbuff.h \
- ../include/dcmtk/oflog/helpers/lloguser.h \
+ ../include/dcmtk/oflog/logmacro.h ../include/dcmtk/oflog/logger.h \
+ ../include/dcmtk/oflog/spi/apndatch.h \
+ ../include/dcmtk/oflog/spi/logfact.h \
+ ../include/dcmtk/oflog/helpers/snprintf.h \
+ ../include/dcmtk/oflog/tracelog.h \
  ../include/dcmtk/oflog/helpers/loglog.h \
+ ../include/dcmtk/oflog/helpers/property.h \
+ ../../ofstd/include/dcmtk/ofstd/ofmap.h \
+ ../../ofstd/include/dcmtk/ofstd/oflist.h \
+ ../include/dcmtk/oflog/helpers/strhelp.h \
+ ../include/dcmtk/oflog/spi/logevent.h ../include/dcmtk/oflog/ndc.h \
+ ../include/dcmtk/oflog/mdc.h ../include/dcmtk/oflog/helpers/timehelp.h \
+ ../include/dcmtk/oflog/thread/threads.h \
+ ../include/dcmtk/oflog/internal/internal.h \
+ ../include/dcmtk/oflog/thread/impl/tls.h \
+ ../include/dcmtk/oflog/internal/env.h \
+ ../include/dcmtk/oflog/thread/syncpub.h
+threads.o: threads.cc ../include/dcmtk/oflog/config.h \
+ ../../config/include/dcmtk/config/osconfig.h \
+ ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
+ ../../ofstd/include/dcmtk/ofstd/ofcast.h \
+ ../../ofstd/include/dcmtk/ofstd/ofexport.h \
+ ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
+ ../include/dcmtk/oflog/config/defines.h \
+ ../include/dcmtk/oflog/helpers/threadcf.h \
+ ../include/dcmtk/oflog/config/windowsh.h \
+ ../include/dcmtk/oflog/thread/syncpub.h ../include/dcmtk/oflog/tstring.h \
+ ../../ofstd/include/dcmtk/ofstd/ofstring.h \
+ ../../ofstd/include/dcmtk/ofstd/oftypes.h \
+ ../../ofstd/include/dcmtk/ofstd/ofstream.h \
+ ../include/dcmtk/oflog/tchar.h \
+ ../include/dcmtk/oflog/internal/cygwin32.h \
+ ../include/dcmtk/oflog/streams.h ../include/dcmtk/oflog/thread/threads.h \
  ../include/dcmtk/oflog/helpers/pointer.h \
- ../include/dcmtk/oflog/helpers/threads.h \
- ../include/dcmtk/oflog/spi/logevent.h ../include/dcmtk/oflog/loglevel.h \
- ../include/dcmtk/oflog/streams.h ../include/dcmtk/oflog/ndc.h \
- ../../ofstd/include/dcmtk/ofstd/ofstack.h \
+ ../include/dcmtk/oflog/thread/syncprim.h \
+ ../include/dcmtk/oflog/thread/impl/thredimp.h \
+ ../include/dcmtk/oflog/thread/impl/tls.h ../include/dcmtk/oflog/ndc.h \
+ ../../ofstd/include/dcmtk/ofstd/ofvector.h \
+ ../include/dcmtk/oflog/helpers/loglog.h \
+ ../include/dcmtk/oflog/helpers/strhelp.h \
  ../include/dcmtk/oflog/helpers/timehelp.h \
- ../../ofstd/include/dcmtk/ofstd/ofaptr.h
-winconap.o: winconap.cc ../include/dcmtk/oflog/winconap.h \
+ ../include/dcmtk/oflog/internal/internal.h ../include/dcmtk/oflog/mdc.h \
+ ../../ofstd/include/dcmtk/ofstd/ofmap.h \
+ ../../ofstd/include/dcmtk/ofstd/oflist.h \
+ ../include/dcmtk/oflog/spi/logevent.h \
+ ../../ofstd/include/dcmtk/ofstd/ofaptr.h \
+ ../include/dcmtk/oflog/loglevel.h \
+ ../include/dcmtk/oflog/helpers/snprintf.h
+timehelp.o: timehelp.cc ../include/dcmtk/oflog/helpers/timehelp.h \
  ../include/dcmtk/oflog/config.h \
  ../../config/include/dcmtk/config/osconfig.h \
  ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
@@ -889,15 +1320,26 @@ winconap.o: winconap.cc ../include/dcmtk/oflog/winconap.h \
  ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
  ../include/dcmtk/oflog/config/defines.h \
  ../include/dcmtk/oflog/helpers/threadcf.h \
- ../include/dcmtk/oflog/helpers/loglog.h ../include/dcmtk/oflog/tstring.h \
+ ../include/dcmtk/oflog/tstring.h \
  ../../ofstd/include/dcmtk/ofstd/ofstring.h \
  ../../ofstd/include/dcmtk/ofstd/oftypes.h \
  ../../ofstd/include/dcmtk/ofstd/ofstream.h \
- ../include/dcmtk/oflog/helpers/pointer.h \
- ../include/dcmtk/oflog/helpers/threads.h \
+ ../include/dcmtk/oflog/tchar.h ../include/dcmtk/oflog/helpers/loglog.h \
+ ../include/dcmtk/oflog/streams.h \
+ ../include/dcmtk/oflog/thread/syncprim.h \
  ../include/dcmtk/oflog/helpers/strhelp.h \
- ../../ofstd/include/dcmtk/ofstd/oflist.h
-windebap.o: windebap.cc ../include/dcmtk/oflog/windebap.h \
+ ../../ofstd/include/dcmtk/ofstd/ofvector.h \
+ ../include/dcmtk/oflog/internal/internal.h ../include/dcmtk/oflog/ndc.h \
+ ../include/dcmtk/oflog/mdc.h ../../ofstd/include/dcmtk/ofstd/ofmap.h \
+ ../../ofstd/include/dcmtk/ofstd/oflist.h \
+ ../include/dcmtk/oflog/spi/logevent.h \
+ ../../ofstd/include/dcmtk/ofstd/ofaptr.h \
+ ../include/dcmtk/oflog/loglevel.h \
+ ../include/dcmtk/oflog/thread/threads.h \
+ ../include/dcmtk/oflog/helpers/pointer.h \
+ ../include/dcmtk/oflog/thread/impl/tls.h \
+ ../include/dcmtk/oflog/helpers/snprintf.h
+tls.o: tls.cc ../include/dcmtk/oflog/thread/impl/tls.h \
  ../include/dcmtk/oflog/config.h \
  ../../config/include/dcmtk/config/osconfig.h \
  ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
@@ -906,8 +1348,7 @@ windebap.o: windebap.cc ../include/dcmtk/oflog/windebap.h \
  ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
  ../include/dcmtk/oflog/config/defines.h \
  ../include/dcmtk/oflog/helpers/threadcf.h
-winsock.o: winsock.cc ../include/dcmtk/oflog/helpers/socket.h \
- ../include/dcmtk/oflog/config.h \
+unixsock.o: unixsock.cc ../include/dcmtk/oflog/config.h \
  ../../config/include/dcmtk/config/osconfig.h \
  ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
  ../../ofstd/include/dcmtk/ofstd/ofcast.h \
@@ -915,12 +1356,55 @@ winsock.o: winsock.cc ../include/dcmtk/oflog/helpers/socket.h \
  ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
  ../include/dcmtk/oflog/config/defines.h \
  ../include/dcmtk/oflog/helpers/threadcf.h \
- ../include/dcmtk/oflog/tstring.h \
- ../../ofstd/include/dcmtk/ofstd/ofstring.h \
+ ../../ofstd/include/dcmtk/ofstd/ofvector.h \
  ../../ofstd/include/dcmtk/ofstd/oftypes.h \
+ ../include/dcmtk/oflog/internal/socket.h \
+ ../include/dcmtk/oflog/helpers/socket.h ../include/dcmtk/oflog/tstring.h \
+ ../../ofstd/include/dcmtk/ofstd/ofstring.h \
  ../../ofstd/include/dcmtk/ofstd/ofstream.h \
- ../include/dcmtk/oflog/helpers/sockbuff.h \
- ../include/dcmtk/oflog/helpers/lloguser.h \
- ../include/dcmtk/oflog/helpers/loglog.h \
+ ../include/dcmtk/oflog/tchar.h ../include/dcmtk/oflog/helpers/sockbuff.h \
+ ../include/dcmtk/oflog/helpers/loglog.h ../include/dcmtk/oflog/streams.h \
+ ../include/dcmtk/oflog/thread/syncprim.h \
+ ../include/dcmtk/oflog/thread/syncpub.h \
+ ../include/dcmtk/oflog/spi/logevent.h \
+ ../../ofstd/include/dcmtk/ofstd/ofaptr.h \
+ ../include/dcmtk/oflog/loglevel.h ../include/dcmtk/oflog/ndc.h \
+ ../include/dcmtk/oflog/mdc.h ../../ofstd/include/dcmtk/ofstd/ofmap.h \
+ ../../ofstd/include/dcmtk/ofstd/oflist.h \
+ ../include/dcmtk/oflog/helpers/timehelp.h \
+ ../include/dcmtk/oflog/thread/threads.h \
  ../include/dcmtk/oflog/helpers/pointer.h \
- ../include/dcmtk/oflog/helpers/threads.h
+ ../include/dcmtk/oflog/helpers/strhelp.h
+version.o: version.cc ../include/dcmtk/oflog/version.h \
+ ../include/dcmtk/oflog/config.h \
+ ../../config/include/dcmtk/config/osconfig.h \
+ ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
+ ../../ofstd/include/dcmtk/ofstd/ofcast.h \
+ ../../ofstd/include/dcmtk/ofstd/ofexport.h \
+ ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
+ ../include/dcmtk/oflog/config/defines.h \
+ ../include/dcmtk/oflog/helpers/threadcf.h
+winconap.o: winconap.cc ../include/dcmtk/oflog/config.h \
+ ../../config/include/dcmtk/config/osconfig.h \
+ ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
+ ../../ofstd/include/dcmtk/ofstd/ofcast.h \
+ ../../ofstd/include/dcmtk/ofstd/ofexport.h \
+ ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
+ ../include/dcmtk/oflog/config/defines.h \
+ ../include/dcmtk/oflog/helpers/threadcf.h
+windebap.o: windebap.cc ../include/dcmtk/oflog/config.h \
+ ../../config/include/dcmtk/config/osconfig.h \
+ ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
+ ../../ofstd/include/dcmtk/ofstd/ofcast.h \
+ ../../ofstd/include/dcmtk/ofstd/ofexport.h \
+ ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
+ ../include/dcmtk/oflog/config/defines.h \
+ ../include/dcmtk/oflog/helpers/threadcf.h
+winsock.o: winsock.cc ../include/dcmtk/oflog/config.h \
+ ../../config/include/dcmtk/config/osconfig.h \
+ ../../ofstd/include/dcmtk/ofstd/ofdefine.h \
+ ../../ofstd/include/dcmtk/ofstd/ofcast.h \
+ ../../ofstd/include/dcmtk/ofstd/ofexport.h \
+ ../../ofstd/include/dcmtk/ofstd/ofstdinc.h \
+ ../include/dcmtk/oflog/config/defines.h \
+ ../include/dcmtk/oflog/helpers/threadcf.h
diff --git a/oflog/libsrc/apndimpl.cc b/oflog/libsrc/apndimpl.cc
index 8564c42..16f886d 100644
--- a/oflog/libsrc/apndimpl.cc
+++ b/oflog/libsrc/apndimpl.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -23,14 +23,13 @@
 #include "dcmtk/oflog/helpers/apndimpl.h"
 #include "dcmtk/oflog/helpers/loglog.h"
 #include "dcmtk/oflog/spi/logevent.h"
+#include "dcmtk/oflog/thread/syncpub.h"
 
-//#include <algorithm>
+#include <algorithm>
 
 
 namespace dcmtk
 {
-
-
 namespace log4cplus
 {
 
@@ -51,47 +50,39 @@ namespace helpers
 
 
 //////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::helpers::AppenderAttachableImpl ctor and dtor
+// log4cplus::helpers::AppenderAttachableImpl ctor and dtor
 //////////////////////////////////////////////////////////////////////////////
 
-AppenderAttachableImpl::AppenderAttachableImpl()
- : appender_list_mutex(DCMTK_LOG4CPLUS_MUTEX_CREATE)
-{
-}
+AppenderAttachableImpl::AppenderAttachableImpl() :
+    appender_list_mutex(),
+    appenderList()
+{ }
 
 
 AppenderAttachableImpl::~AppenderAttachableImpl()
-{
-   DCMTK_LOG4CPLUS_MUTEX_FREE( appender_list_mutex );
-}
+{ }
 
 
 
 ///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::helpers::AppenderAttachableImpl public methods
+// log4cplus::helpers::AppenderAttachableImpl public methods
 ///////////////////////////////////////////////////////////////////////////////
 
 void
 AppenderAttachableImpl::addAppender(SharedAppenderPtr newAppender)
 {
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( appender_list_mutex )
-        if(newAppender == NULL) {
-            getLogLog().warn( DCMTK_LOG4CPLUS_TEXT("Tried to add NULL appender") );
-            return;
-        }
+    if(newAppender == NULL) {
+        getLogLog().warn( DCMTK_LOG4CPLUS_TEXT("Tried to add NULL appender") );
+        return;
+    }
 
-        ListIteratorType it = appenderList.begin();
-        while (it != appenderList.end())
-        {
-            if (*it == newAppender)
-                break;
-            it++;
-        }
+    thread::MutexGuard guard (appender_list_mutex);
 
-        if(it == appenderList.end()) {
-            appenderList.push_back(newAppender);
-        }
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+    ListType::iterator it = 
+        STD_NAMESPACE find(appenderList.begin(), appenderList.end(), newAppender);
+    if(it == appenderList.end()) {
+        appenderList.push_back(newAppender);
+    }
 }
 
 
@@ -99,43 +90,43 @@ AppenderAttachableImpl::addAppender(SharedAppenderPtr newAppender)
 AppenderAttachableImpl::ListType
 AppenderAttachableImpl::getAllAppenders()
 {
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( appender_list_mutex )
-        return appenderList;
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+    thread::MutexGuard guard (appender_list_mutex);
+    
+    return appenderList;
 }
 
 
 
-SharedAppenderPtr
-AppenderAttachableImpl::getAppender(const tstring& name)
+SharedAppenderPtr 
+AppenderAttachableImpl::getAppender(const log4cplus::tstring& name)
 {
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( appender_list_mutex )
-        for(ListIteratorType it=appenderList.begin();
-            it!=appenderList.end();
-            ++it)
-        {
-            if((*it)->getName() == name) {
-                return *it;
-            }
+    thread::MutexGuard guard (appender_list_mutex);
+
+    for(ListType::iterator it=appenderList.begin(); 
+        it!=appenderList.end(); 
+        ++it)
+    {
+        if((*it)->getName() == name) {
+            return *it;
         }
+    }
 
-        return SharedAppenderPtr(NULL);
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+    return SharedAppenderPtr(NULL);
 }
 
 
 
-void
+void 
 AppenderAttachableImpl::removeAllAppenders()
 {
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( appender_list_mutex )
-        appenderList.erase(appenderList.begin(), appenderList.end());
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+    thread::MutexGuard guard (appender_list_mutex);
+
+    appenderList.clear();
 }
 
 
 
-void
+void 
 AppenderAttachableImpl::removeAppender(SharedAppenderPtr appender)
 {
     if(appender == NULL) {
@@ -143,46 +134,39 @@ AppenderAttachableImpl::removeAppender(SharedAppenderPtr appender)
         return;
     }
 
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( appender_list_mutex )
-        ListIteratorType it = appenderList.begin();
+    thread::MutexGuard guard (appender_list_mutex);
 
-        while (it != appenderList.end())
-        {
-            if (*it == appender)
-                break;
-            it++;
-        }
-
-        if(it != appenderList.end()) {
-            appenderList.erase(it);
-        }
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+    ListType::iterator it =
+        STD_NAMESPACE find(appenderList.begin(), appenderList.end(), appender);
+    if(it != appenderList.end()) {
+        appenderList.erase(it);
+    }
 }
 
 
 
-void
-AppenderAttachableImpl::removeAppender(const tstring& name)
+void 
+AppenderAttachableImpl::removeAppender(const log4cplus::tstring& name)
 {
     removeAppender(getAppender(name));
 }
 
 
 
-int
+int 
 AppenderAttachableImpl::appendLoopOnAppenders(const spi::InternalLoggingEvent& event) const
 {
     int count = 0;
 
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( appender_list_mutex )
-        for(ListConstIteratorType it=appenderList.begin();
-            it!=appenderList.end();
-            ++it)
-        {
-            ++count;
-            (*it)->doAppend(event);
-        }
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+    thread::MutexGuard guard (appender_list_mutex);
+
+    for(ListType::const_iterator it=appenderList.begin();
+        it!=appenderList.end();
+        ++it)
+    {
+        ++count;
+        (*it)->doAppend(event);
+    }
 
     return count;
 }
@@ -192,6 +176,4 @@ AppenderAttachableImpl::appendLoopOnAppenders(const spi::InternalLoggingEvent& e
 
 
 } // namespace log4cplus
-
-
-} // namespace dcmtk
+} // end namespace dcmtk
